#include <cmath>
#include <cstdio>
#include <cstring>
#include <cstdlib>

using namespace std;

extern float  calcul_decliner(float w, float x, float y, float z)
{     extern void geomag(int *), geomg1(float ,float ,float ,float ,float *,float *,float *,float *);
	
	static int maxdeg;
	static float dlat, dlon;
	static float ati, adec, adip;
	static float alt, time, dec, dip, ti, gv;
	static float time1, dec1, dip1, ti1;
	static float time2, dec2, dip2, ti2;
	float x1,x2,y1,y2,z1,z2,h1,h2;
	float ax,ay,az,ah;
	float rTd=0.017453292;
	
	/* INITIALIZE GEOMAG ROUTINE */
	//S1:
	maxdeg = 12;
	geomag(&maxdeg);
	
	dlat=w;
	dlon=x;
	time=y;
	alt=z;
	
	geomg1(alt,dlat,dlon,time,&dec,&dip,&ti,&gv);
	time1 = time;
	dec1 = dec;
	dip1 = dip;
	ti1 = ti;
	time = time1 + 1.0;
	
	geomg1(alt,dlat,dlon,time,&dec,&dip,&ti,&gv);
	time2 = time;
	dec2 = dec;
	dip2 = dip;
	ti2 = ti;
	
	/*COMPUTE X, Y, Z, AND H COMPONENTS OF THE MAGNETIC FIELD*/
	
	x1=ti1*(cos((dec1*rTd))*cos((dip1*rTd)));
	x2=ti2*(cos((dec2*rTd))*cos((dip2*rTd)));
	y1=ti1*(cos((dip1*rTd))*sin((dec1*rTd)));
	y2=ti2*(cos((dip2*rTd))*sin((dec2*rTd)));
	z1=ti1*(sin((dip1*rTd)));
	z2=ti2*(sin((dip2*rTd)));
	h1=ti1*(cos((dip1*rTd)));
	h2=ti2*(cos((dip2*rTd)));
	
	/*  COMPUTE ANNUAL CHANGE FOR TOTAL INTENSITY  */
	ati = ti2 - ti1;
	
	/*  COMPUTE ANNUAL CHANGE FOR DIP & DEC  */
	adip = (dip2 - dip1) * 60.;
	adec = (dec2 - dec1) * 60.;
	
	/*  COMPUTE ANNUAL CHANGE FOR X, Y, Z, AND H */
	ax = x2-x1;
	ay = y2-y1;
	az = z2-z1;
	ah = h2-h1;
	
	return dec1;
}
/*************************************************************************/
/*                  FIN calcul_decliner()                                        */
/*************************************************************************/


/*************************************************************************/
/*                  Fontion E0000()                                        */
/*************************************************************************/

static void E0000(int IENTRY,int *maxdeg,float alt,float glat,float glon,float time,float *dec,float *dip,float *ti,float *gv)
{     static int maxord,i,icomp,n,m,j,D1,D2,D3,D4;
	static float c[13][13],cd[13][13],tc[13][13],dp[13][13],snorm[169],
	sp[13],cp[13],fn[13],fm[13],pp[13],k[13][13],pi,dtr,a,b,re,
	a2,b2,c2,a4,b4,c4,epoch,gnm,hnm,dgnm,dhnm,flnmj,otime,oalt,
	olat,olon,dt,rlon,rlat,srlon,srlat,crlon,crlat,srlat2,
	crlat2,q,q1,q2,ct,st,r2,r,d,ca,sa,aor,ar,br,bt,bp,bpp,
	
	par,temp1,temp2,parp,bx,by,bz,bh;
	static char model[20], c_str[81], c_new[5];
	static float *p = snorm;
	
	int sizemax, ret;
	
	FILE *wmmdat;
	
	switch(IENTRY)
	{  case 0: goto GEOMAG; case 1: goto GEOMG1;
	}
	
	GEOMAG:
		wmmdat = fopen("WMM.COF","r");
		if (wmmdat==NULL)
		{ perror("WMM.COF");
			exit(2);
		}
		
		
		/* INITIALIZE CONSTANTS */
		maxord = *maxdeg;
		sp[0] = 0.0;
		cp[0] = *p = pp[0] = 1.0;
		dp[0][0] = 0.0;
		a = 6378.137;
		b = 6356.7523142;
		re = 6371.2;
		a2 = a*a;
		b2 = b*b;
		c2 = a2-b2;
		a4 = a2*a2;
		b4 = b2*b2;
		c4 = a4 - b4;                                                                
		
		/* READ WORLD MAGNETIC MODEL SPHERICAL HARMONIC COEFFICIENTS */
		c[0][0] = 0.0;
		cd[0][0] = 0.0;
				
		sizemax=80;
		fgets(c_str, sizemax, wmmdat);
		ret = sscanf(c_str,"%f%s",&epoch,model);
		if(ret != 2)
		{ printf("Pb with :\"epoch\" ou \"model\" a partir de \"WMM.COF\"\n");
			exit(2);
		}
		
		S3:
		fgets(c_str, sizemax, wmmdat);
		/* CHECK FOR LAST LINE IN FILE */
		for (i=0; i<4 && (c_str[i] != '\0'); i++)
		{ c_new[i] = c_str[i];
			c_new[i+1] = '\0';
		}
		icomp = strcmp("9999", c_new);
		if (icomp == 0) goto S4;
		
		/* END OF FILE NOT ENCOUNTERED, GET VALUES */
		sscanf(c_str,"%d%d%f%f%f%f",&n,&m,&gnm,&hnm,&dgnm,&dhnm);
		if (m <= n)
		{ c[m][n] = gnm;
			cd[m][n] = dgnm;
			if (m != 0)
			{ c[n][m-1] = hnm;
				cd[n][m-1] = dhnm;
			}
		}
		goto S3;
		
		/* CONVERT SCHMIDT NORMALIZED GAUSS COEFFICIENTS TO UNNORMALIZED */
		S4:
		*snorm = 1.0;
		for (n=1; n<=maxord; n++)
		{ *(snorm+n) = *(snorm+n-1)*(float)(2*n-1)/(float)n;
			j = 2;
			for (m=0,D1=1,D2=(n-m+D1)/D1; D2>0; D2--,m+=D1)
			{ k[m][n] = (float)(((n-1)*(n-1))-(m*m))/(float)((2*n-1)*(2*n-3));
				if (m > 0)
				{ flnmj = (float)((n-m+1)*j)/(float)(n+m);
					*(snorm+n+m*13) = *(snorm+n+(m-1)*13)*sqrt(flnmj);
					j = 1;
					c[n][m-1] = *(snorm+n+m*13)*c[n][m-1];
					cd[n][m-1] = *(snorm+n+m*13)*cd[n][m-1];
				}
				c[m][n] = *(snorm+n+m*13)*c[m][n];
				cd[m][n] = *(snorm+n+m*13)*cd[m][n];
			}
			fn[n] = (float)(n+1);
			fm[n] = (float)n;
		}
		k[1][1] = 0.0;
		
		otime = oalt = olat = olon = -1000.0;
		fclose(wmmdat);
		return;
		
		/*************************************************************************/
		
		GEOMG1:
			
			dt = time - epoch;
			pi = 3.14159265359;
			dtr = pi/180.0;
			rlon = glon*dtr;
			rlat = glat*dtr;
			srlon = sin(rlon);
			srlat = sin(rlat);
			crlon = cos(rlon);
			crlat = cos(rlat);
			srlat2 = srlat*srlat;
			crlat2 = crlat*crlat;
			sp[1] = srlon;
			cp[1] = crlon;
			
			/* CONVERT FROM GEODETIC COORDS. TO SPHERICAL COORDS. */
			if (alt != oalt || glat != olat)
			{ q = sqrt(a2-c2*srlat2);
				q1 = alt*q;
				q2 = ((q1+a2)/(q1+b2))*((q1+a2)/(q1+b2));
				ct = srlat/sqrt(q2*crlat2+srlat2);
				st = sqrt(1.0-(ct*ct));
				r2 = (alt*alt)+2.0*q1+(a4-c4*srlat2)/(q*q);
				r = sqrt(r2);
				d = sqrt(a2*crlat2+b2*srlat2);
				ca = (alt+d)/r;
				sa = c2*crlat*srlat/(r*d);
			}
			if (glon != olon)
			{ for (m=2; m<=maxord; m++)
				{ sp[m] = sp[1]*cp[m-1]+cp[1]*sp[m-1];
					cp[m] = cp[1]*cp[m-1]-sp[1]*sp[m-1];
				}
			}
			aor = re/r;
			ar = aor*aor;
			br = bt = bp = bpp = 0.0;
			for (n=1; n<=maxord; n++)
			{ ar = ar*aor;
				for (m=0,D3=1,D4=(n+m+D3)/D3; D4>0; D4--,m+=D3)
				{ if (alt != oalt || glat != olat)  //   COMPUTE UNNORMALIZED ASSOCIATED LEGENDRE POLYNOMIALS
					{ if (n == m)                     //   AND DERIVATIVES VIA RECURSION RELATIONS
						{ *(p+n+m*13) = st**(p+n-1+(m-1)*13);
							dp[m][n] = st*dp[m-1][n-1]+ct**(p+n-1+(m-1)*13);
							goto S50;
						}
						if (n == 1 && m == 0)
						{ *(p+n+m*13) = ct**(p+n-1+m*13);
							dp[m][n] = ct*dp[m][n-1]-st**(p+n-1+m*13);
							goto S50;
						}
						if (n > 1 && n != m)
						{ if (m > n-2) *(p+n-2+m*13) = 0.0;
							if (m > n-2) dp[m][n-2] = 0.0;
							*(p+n+m*13) = ct**(p+n-1+m*13)-k[m][n]**(p+n-2+m*13);
							dp[m][n] = ct*dp[m][n-1] - st**(p+n-1+m*13)-k[m][n]*dp[m][n-2];
						}
					}
					S50:
						if (time != otime)  //  TIME ADJUST THE GAUSS COEFFICIENTS
						{ tc[m][n] = c[m][n]+dt*cd[m][n];
							if (m != 0) tc[n][m-1] = c[n][m-1]+dt*cd[n][m-1];
						}
						/*
		ACCUMULATE TERMS OF THE SPHERICAL HARMONIC EXPANSIONS
*/
						par = ar**(p+n+m*13);
						if (m == 0)
						{ temp1 = tc[m][n]*cp[m];
							temp2 = tc[m][n]*sp[m];
						}
						else
						{ temp1 = tc[m][n]*cp[m]+tc[n][m-1]*sp[m];
							temp2 = tc[m][n]*sp[m]-tc[n][m-1]*cp[m];
						}
						bt = bt-ar*temp1*dp[m][n];
						bp += (fm[m]*temp2*par);
						br += (fn[n]*temp1*par);
						/*
		SPECIAL CASE:  NORTH/SOUTH GEOGRAPHIC POLES
*/
						if (st == 0.0 && m == 1)
						{ if (n == 1) pp[n] = pp[n-1];
							else pp[n] = ct*pp[n-1]-k[m][n]*pp[n-2];
							parp = ar*pp[n];
							bpp += (fm[m]*temp2*parp);
						}
					}
			}
			if (st == 0.0) bp = bpp;
			else bp /= st;
			/*
		ROTATE MAGNETIC VECTOR COMPONENTS FROM SPHERICAL TO
		GEODETIC COORDINATES
*/
			bx = -bt*ca-br*sa;
			by = bp;
			bz = bt*sa-br*ca;
			/*
		COMPUTE DECLINATION (DEC), INCLINATION (DIP) AND
		TOTAL INTENSITY (TI)
*/
			bh = sqrt((bx*bx)+(by*by));
			*ti = sqrt((bh*bh)+(bz*bz));
			*dec = atan2(by,bx)/dtr;
			*dip = atan2(bz,bh)/dtr;
			/*
		COMPUTE MAGNETIC GRID VARIATION IF THE CURRENT
		GEODETIC POSITION IS IN THE ARCTIC OR ANTARCTIC
		(I.E. GLAT > +55 DEGREES OR GLAT < -55 DEGREES)
		
		OTHERWISE, SET MAGNETIC GRID VARIATION TO -999.0
*/
			*gv = -999.0;
			if (fabs(glat) >= 55.)
			{ if (glat > 0.0 && glon >= 0.0) *gv = *dec-glon;
				if (glat > 0.0 && glon < 0.0) *gv = *dec+fabs(glon);
				if (glat < 0.0 && glon >= 0.0) *gv = *dec+glon;
				if (glat < 0.0 && glon < 0.0) *gv = *dec-fabs(glon);
				if (*gv > +180.0) *gv -= 360.0;
				if (*gv < -180.0) *gv += 360.0;
			}
			otime = time;
			oalt = alt;
			olat = glat;
			olon = glon;
			return;
		}
/*************************************************************************/
/*                  FIN Fontion E0000()                                        */
/*************************************************************************/

/*************************************************************************/

void geomag(int *maxdeg)
{
	E0000(0,maxdeg,0.0,0.0,0.0,0.0,NULL,NULL,NULL,NULL);
}                                      

/*************************************************************************/

void geomg1(float alt,float glat,float glon,float time,float *dec,float *dip,float *ti,float *gv)
{
	E0000(1,NULL,alt,glat,glon,time,dec,dip,ti,gv);
}


